Bug 1012686 - package request: install BFO in grub (boot.fedora.org)
package request: install BFO in grub (boot.fedora.org)
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: distribution (Show other bugs)
25
Unspecified Unspecified
unspecified Severity low
: ---
: ---
Assigned To: Kevin Fenzi
Fedora Extras Quality Assurance
: Reopened
Depends On: 1000322
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-26 17:44 EDT by Colin Macdonald
Modified: 2017-11-16 13:50 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-07-19 16:03:02 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
bfo.spec (2.22 KB, text/x-rpm-spec)
2013-10-14 17:39 EDT, Colin Macdonald
no flags Details
bfo.spec (2.16 KB, text/x-rpm-spec)
2013-10-16 06:06 EDT, Colin Macdonald
no flags Details
bfo.spec, fix changelog (2.16 KB, text/x-rpm-spec)
2013-10-16 06:11 EDT, Colin Macdonald
no flags Details

  None (edit)
Description Colin Macdonald 2013-09-26 17:44:41 EDT
BFO is cool.  A rpm package that would install it on grub would be nice.

Its easy to do manually:

>  wget -O/boot/bfo.lkrn http://dl.fedoraproject.org/pub/alt/bfo/bfo.lkrn
>  grubby --add-kernel=/boot/bfo.lkrn --title="Boot BFO"
>  reboot
        
(src: http://boot.fedoraproject.org/faq)

If it was a package, I wouldn't have to remember to do it everytime I reinstall fedora.  c.f., memtest86+.
Comment 1 Kevin Fenzi 2013-10-01 19:15:00 EDT
Not a bad idea... I'm afraid I don't have time to work on it currently however. 

Would you (or someone you know) be interested in creating the package? I could help review.
Comment 2 Colin Macdonald 2013-10-14 17:39:51 EDT
Created attachment 812243 [details]
bfo.spec

Here's my rough attempt.

* Foolishly, I haven't actually tested booting the result (next time I have an ethernet connection...)

* Here's the SRPM:

http://people.maths.ox.ac.uk/macdonald/temp/bfo-1.0.0-1.20130925git7405685df.fc19.src.rpm

* I've got the spec file and other bits and pieces on github:

https://github.com/cbm755/fedora-bfo-rpm

* rpmlint reports errors, other issues noted in TODO.md on github.
Comment 3 Kevin Fenzi 2013-10-15 23:18:49 EDT
So, a few things... do we want the package to build the file, or just have some kind of wrapper that asks the user when they run it to download the one already built on boot.fedoraproject.org? On one hand it would need net and prompting, on the other it would avoid different versions. 

Instead of grub2-mkconfig you likely want to call 'grubby' to add the entry.
Comment 4 Colin Macdonald 2013-10-16 06:02:42 EDT
I don't have a strong opinion but here's my thinking:

1)  Fedora documentation suggests packages should be able to build
    from source.

2)  We can control what checkout from ipxe is used so controlling
    versions should be easy.

3)  I tried to have an RPM that does the steps in:

    https://git.fedorahosted.org/cgit/fedora-infrastructure.git/tree/bfo/README

    So one could in the future use the RPM intead of those instructions...

4)  You could put the .spec file and other bits info the
    fedora-infrastructure repo.

Re: grubby.  I put the entry in /etc/grub.d/ but then I don't know what grubby command rebuilds grub2.cfg.  I did take a quick look at the kernel rpm's but I didn't see how to do it.

FWIW, I think the grubby instructions at http://boot.fedoraproject.org/faq are suboptimal b/c AFAICT the command modifies grub2.cfg *directly* (and thus will not survive recreating grub2.cfg).  Putting files into /etc/grub.d/ seems to be The Right Way.
Comment 5 Colin Macdonald 2013-10-16 06:04:56 EDT
sorry, I meant /boot/grub2/grub.cfg
Comment 6 Colin Macdonald 2013-10-16 06:06:24 EDT
Created attachment 812851 [details]
bfo.spec

minor fixes
Comment 7 Colin Macdonald 2013-10-16 06:11:58 EDT
Created attachment 812856 [details]
bfo.spec, fix changelog
Comment 8 Kevin Fenzi 2013-10-21 17:21:22 EDT
I guess the 'official' way to add/update the bootloader these days is to call /sbin/new-kernel-pkg with the right arguments. That would call grubby if grub was used, extlinux updated if thats in use, etc.
Comment 9 Colin Macdonald 2013-12-18 18:52:57 EST
1)  I honestly can't tell what is "official".  I also see this:

https://lists.fedoraproject.org/pipermail/devel/2013-July/184703.html

But at any rate, both "new-kernel-pkg" and "kernel-install" concentrate on *kernels*, i.e., initrd's etc.  I just want to update the /boot/grub2/grub.cfg file ;-)  

My current plan is watch memtest86:

https://bugzilla.redhat.com/show_bug.cgi?id=1000322

Once its sorted there, I'll try to do whatever they do.


2)  I assume Fedora has these extra layers of grubby/new-kernel-pkg/kernel-install etc because we support multiple bootloaders (I can't think of any other reason!)  But does that mean this BFO package needs to support those other bootloaders?  They must each have their equivalent of /etc/grub.d/20_bfo files...
Comment 10 Jaroslav Reznik 2015-03-03 11:55:28 EST
This bug appears to have been reported against 'rawhide' during the Fedora 22 development cycle.
Changing version to '22'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora22
Comment 11 Fedora End Of Life 2016-07-19 16:03:02 EDT
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 12 Colin Macdonald 2016-07-19 16:56:17 EDT
@Kevin: do you think there is still interest in BFO?  It still works my bios rawhide VM... but haven't tested on my EFI laptop.

Assuming there is still interest, maybe I should stop building from source and just grab the current "bfo.lkrn"...  I.e., I could do a much simpler package:

1.  install a "bfo-setup" script (c.f., memtest86+)

2.  bfo-setup would "wget" the latest bfo.lkrn

3.  bfo-setup would write the "etc/grub.d/20_bfo" file

4.  It would tell inform the user to do "grub2-mkconfig -o /boot/grub2/grub.cfg"

(3 and 4 are what memtest86+ still does so its not too unreasonable).
Comment 13 Kevin Fenzi 2016-07-23 18:53:19 EDT
(In reply to Colin Macdonald from comment #12)
> @Kevin: do you think there is still interest in BFO?  It still works my bios
> rawhide VM... but haven't tested on my EFI laptop.

Hard to say. ;) EFI isn't working sadly, see: 
https://bugzilla.redhat.com/show_bug.cgi?id=1215693

> 
> Assuming there is still interest, maybe I should stop building from source
> and just grab the current "bfo.lkrn"...  I.e., I could do a much simpler
> package:
> 
> 1.  install a "bfo-setup" script (c.f., memtest86+)
> 
> 2.  bfo-setup would "wget" the latest bfo.lkrn
> 
> 3.  bfo-setup would write the "etc/grub.d/20_bfo" file
> 
> 4.  It would tell inform the user to do "grub2-mkconfig -o
> /boot/grub2/grub.cfg"
> 
> (3 and 4 are what memtest86+ still does so its not too unreasonable).

That would work for me.
Comment 14 Jan Kurik 2016-07-26 00:30:43 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 25 development cycle.
Changing version to '25'.
Comment 15 Fedora End Of Life 2017-11-16 13:50:49 EST
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Note You need to log in before you can comment on or make changes to this bug.